<?php
namespace Teknisa\PED\Modules\Pedidos\Controllers;

use Teknisa\PED\Controllers\TeknisaCrud;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\Libs\Util\Libraries\PHPMailer;
use Teknisa\PED\Modules\Pedidos\Services\Ped05900ComposicaoPrecoProdutoService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO;
    
    class Ped05900ComposicaoPrecoProdutoController extends TeknisaCrud {
        protected $entityManager;
        protected $environment;
        protected $ComposicaoPrecoProdutoService;
        
        public function __construct($crudService, ParameterBag $parameterBag, $entityManager, $environment, $ComposicaoPrecoProdutoService){
            parent::__construct($crudService, $parameterBag);
            $this->EntityManager = $entityManager;
            $this->Environment = $environment;
            $this->ComposicaoPrecoProdutoService = $ComposicaoPrecoProdutoService;
        }
        
        public function openGridCalc(DTO\Request $request, DTO\Response $response){
            $row = $request->getRow();
            
            $dataSetComp = $this->ComposicaoPrecoProdutoService->openGridCalc($row);
            $response->addDataSet(new DataSet('dataSetComp', $dataSetComp));

        }
        
        public function calculaPrecoProd($request, $response){
            $rows = $request->getRow();
            $row = $rows[0];
            $produtos = $rows[1];
            $cdprecobase = $row['CDPRECOBASE'];
            $precoBase = array();
                
                
            try{
            if($row['CDPRECOBASE'] == "T"){
              $precoBase = $this->ComposicaoPrecoProdutoService->getPrecobase($row['CDPRECOBASE']);  
            }else{
                foreach($cdprecobase as $cdpreco){
                    $preco = array('CDPRECOBASE' => $cdpreco);
                    array_push($precoBase, $preco );
                }
                
            }
            $result = $this->getWhile($produtos, $row, $row['DTINIVALIPB'], $precoBase);
            
            $response->addDataSet(new DataSet('dataSetCalc', $result));
                
            }catch(\Exception $e){
                throw $e;
            }
        }
        
        public function getWhile($produtos, $row, $valIni, $precoBase){

            try{
                $data = date('d/m/Y');
                $cdserro = array();
                $erro = array();
                $cdoperador = $row['CDOPERADOR'];

                foreach($produtos as $prod){
                    foreach($precoBase as $preco){
                        
                        $prod['CDPRECOBASE'] = $preco['CDPRECOBASE'];
                        $result = $this->ComposicaoPrecoProdutoService->CalculaPrecoProd($prod);
                        if($result < 0 or $result === null){
                            $erro['CDPRODUTO'] = $prod['CDPRODUTO'];
                            $erro['NMPRODUTO'] = $prod['NMPRODUTO'];
                            $erro['CDARVPROD'] = $prod['CDPRODUTO'];
                            if($result['VRITEPREBASE'] < 0){
                                $erro['IDERRO']    = 'N';
                            }else if($result['VRITEPREBASE'] === null){
                                $erro['IDERRO']    = 'Z';
                            }
                            array_push($cdserro, $erro);
                        }else{
                           
                           
                           $precoProd = $this->ComposicaoPrecoProdutoService->precoProd($prod);

                           if(isset($precoProd[0]['VRITEPREBASE'])){
                               $this->ComposicaoPrecoProdutoService->updatePrecoProd($prod, $precoProd[0]['DTINIVALIPB']);

                           }else{
                               $this->ComposicaoPrecoProdutoService->insertPrecoProd($prod, $cdoperador, $valIni, $data);
                           }
                           
                           /*$dtinivalid = $this->ComposicaoPrecoProdutoService->precoOpcio($prod);

                           if(isset($dtinivalid[0]['DTINIVALIPB'])){
                               
                               $this->ComposicaoPrecoProdutoService->updatePrecoOpcio($prod, $cdoperador, $valIni, $dtinivalid[0]['DTINIVALIPB']);
                           }*/
                           
                           $histCustProd = $this->ComposicaoPrecoProdutoService->histCustProd($prod);
                           
                           if(empty($histCustProd)){
                               $this->ComposicaoPrecoProdutoService->insereHistCustProd($prod);
                           }else{
                               $this->ComposicaoPrecoProdutoService->updataHistCustProd($prod);
                           }
                        }
                    }
                }
                
                return $cdserro;
                
            } catch (\Exception $e) {
                throw $e;
            }
        }
        
        public function updateForm(DTO\Request $request, DTO\Response $response){
            
            $row = $request->getRow();
            
            $this->ComposicaoPrecoProdutoService->updateForm($row);

        }
        
        
    }
?>