function exp02100_rota_entregaController (ScreenService, General, templateManager, exp02100_rota_entregaService, ZhFilterPreferences, ZHPromise){
    
    this.startFiltering = function(widgetPedidos){
        
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widgetPedidos.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widgetPedidos));
        ZHPromise.all(promises).then(function(rowSetFilter){
        }.bind(this)); 
    };

    this.newRota = function(widget){
        widget.newRow();
        this.controlaStatusWidgets(widget,'MUNICIPIROTA',false);
        this.controlaStatusWidgets(widget,'CLIENROTA',false);
        this.controlaStatusWidgets(widget,'FILIALROTA',false);
        widget.getField('CDROTATRANS').readOnly= false;
        
        exp02100_rota_entregaService.retornaFilial().then(function(filialLogada){
            widget.currentRow.CDFILIAL =  filialLogada[0].CDFILIAL;
        });
        
        exp02100_rota_entregaService.retornaOperadorLogado().then(function(operadorLogado){
            widget.currentRow.CDOPERADOR =  operadorLogado[0].CDOPERADOR;
        });
    };
    
    this.saveRota = function(widget){
        this.controlaStatusWidgets(widget,'MUNICIPIROTA',true);
        this.controlaStatusWidgets(widget,'CLIENROTA',true);
        this.controlaStatusWidgets(widget,'FILIALROTA',true);
        
        General.saveCrud(widget);
    };
    
    this.editRota = function(widget){
        this.controlaStatusWidgets(widget,'MUNICIPIROTA',false);
        this.controlaStatusWidgets(widget,'CLIENROTA',false);
        this.controlaStatusWidgets(widget,'FILIALROTA',false);
        widget.getField('CDROTATRANS').readOnly= true;
        General.edit(widget);
    };
    
    this.deletarRota = function(widget){
        
       ScreenService.confirmMessage(ScreenService.i18n('Delete Register?'), 'question', function (success) {
    
            exp02100_rota_entregaService.deletarRota(widget.currentRow).then(
                function(Success) {
                    ScreenService.closeSwipe().then(function () {
                        widget.activate();
                    });
                    widget.reload();
                },
                function(error){
                    if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                        ScreenService.showMessage('Exclusão não permitida! O registro possui registros filhos.');
                    } else {
                        ScreenService.showMessage(error.message);
                    }
                }
            );
        });
    };
    
    this.cancelarRota = function(widget){
        this.controlaStatusWidgets(widget,'MUNICIPIROTA',true);
        this.controlaStatusWidgets(widget,'CLIENROTA',true);
        this.controlaStatusWidgets(widget,'FILIALROTA',true);
    };
    
    this.newMunicipioRota = function(widget){
        widget.newRow();
        widget.getField('NMPAIS').readOnly= false;
        widget.getField('NMESTADO').readOnly= true;
        widget.getField('NMMUNICIPIO').readOnly= true;
        widget.getField('NMBAIRRO').readOnly= true;
    };
    
    this.editMunicipioRota = function(widget){
        widget.getField('NMESTADO').readOnly= true;
        widget.getField('NMMUNICIPIO').readOnly= true;
        widget.getField('NMBAIRRO').readOnly= true;
        widget.getField('NMPAIS').readOnly= true;
    };

    this.cancelMunicipiRota = function(widget){
        widget.getField('NMPAIS').readOnly= false;
        widget.getField('NMESTADO').readOnly= false;
        widget.getField('NMMUNICIPIO').readOnly= false;
        widget.getField('NMBAIRRO').readOnly= false;
    };
    
    this.newClienteRota = function(widget){
        widget.newRow();
        widget.getField('NRORDCLIROTA').readOnly= false;
        widget.getField('NMRAZSOCCLIE').readOnly= false;
    };
    
    this.editClienteRota = function(widget){
        widget.getField('NRORDCLIROTA').readOnly= true;
        widget.getField('NMRAZSOCCLIE').readOnly= true;
    };
    
    this.newFilialRota = function(widget){
        widget.newRow();
        widget.getField('NMFILIAL').readOnly= false;
    };
    
    this.editFilialRota = function(widget){
        widget.getField('NMFILIAL').readOnly= true;
    };
    
    this.saveComplete = function(widget){
        widget.currentRow.CDFILIAL = widget.getParent().currentRow.CDFILIAL;
        widget.currentRow.CDROTATRANS = widget.getParent().currentRow.CDROTATRANS;
        General.saveCrud(widget);
    };
    
    this.controlaStatusWidgets = function(mainWidget, nomeWidgetAtual, status){
        mainWidget.widgets.forEach(function(widg) {
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(mainWidget.name !== nomeWidgetAtual)
            mainWidget.enabled = status;
    };
    
    this.preLoadAutocomplete = function(widget){
      if(widget.dataSource.data.length === 0)
        widget.reload();
    };

    this.limparValorPais = function(){
        var widget = templateManager.container.getActiveWidget();
        var pais = widget.getField('NMPAIS');
        if(pais.value()){
            widget.getField('NMESTADO').value("");
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('SGESTADO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMESTADO').readOnly= false;
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMESTADO').reload();
        }else{
            widget.getField('NMESTADO').value("");
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('SGESTADO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMESTADO').readOnly= true;
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMESTADO').reload();
        }
    };

    this.limparValorEstado= function(){
        var widget = templateManager.container.getActiveWidget();
        var estado = widget.getField('NMESTADO');
        if(estado.value()){
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMMUNICIPIO').readOnly= false;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMMUNICIPIO').reload();
        }else{
            widget.getField('NMMUNICIPIO').value("");
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('CDMUNICIPIO').value("");
            widget.getField('NMMUNICIPIO').readOnly= true;
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMMUNICIPIO').reload();
        }
    };

    this.limparValorMunicipio = function(){
        var widget = templateManager.container.getActiveWidget();
        var municipio = widget.getField('NMMUNICIPIO');
        if(municipio.value()){
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('NMBAIRRO').readOnly= false;
            widget.getField('NMBAIRRO').reload();
        }else{
            widget.getField('NMBAIRRO').value("");
            widget.getField('CDBAIRRO').value("");
            widget.getField('NMBAIRRO').readOnly= true;
            widget.getField('NMBAIRRO').reload();
        }
    };

    this.verificaFieldOnChangePais = function(endereco){
        var widget =templateManager.container.getWidget('exp02100_rota_entrega');
        if(!endereco){
            widget.getField('NMPAIS').value('');
            widget.getField('CDPAIS').value('');


            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMESTADO').value('');
            widget.getField('SGESTADO').value('');


            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMMUNICIPIO').value('');
            widget.getField('CDMUNICIPIO').value('');

            widget.getField('NMBAIRRO').readOnly = true;
            widget.getField('NMBAIRRO').value('');
            widget.getField('CDBAIRRO').value('');
        }
        else{
            var pais = endereco.NMPAIS;
            var estado = endereco.NMESTADO;
            var municipio = endereco.NMMUNICIPIO;
            if(!pais){
            widget.getField('NMESTADO').readOnly = true;
            widget.getField('NMMUNICIPIO').readOnly = true;
            widget.getField('NMBAIRRO').readOnly = true;
            }
            else{
                if(!estado){
                    widget.getField('NMESTADO').readOnly = false;
                    widget.getField('NMMUNICIPIO').readOnly = true;
                    widget.getField('NMBAIRRO').readOnly = true;
                }
                else{
                    widget.getField('NMESTADO').readOnly = false;
                    if(!municipio){
                        widget.getField('NMMUNICIPIO').readOnly = false;
                        widget.getField('NMBAIRRO').readOnly = true;

                    }
                    else{
                    widget.getField('NMMUNICIPIO').readOnly = false;
                    widget.getField('NMBAIRRO').readOnly = false;
                    }
                }
            }
        }
    };
    
}

Configuration(function(ContextRegister){
    ContextRegister.register('exp02100_rota_entregaController', exp02100_rota_entregaController);
});